n = 500;

% Create a reasonable bin distance for a one-dimensional problem
D = zeros(n,n);
for i=1:n
    for j=1:n
        D(i,j)=abs(i-j); % bins i and j are |i-j| apart
    end
end

% Compute distance between two extremal histograms
p = ones(n,1)*.1; % recall you can't have any zeros in p,q 
q = ones(n,1)*.1;

alphas = [.1 1 10 100];

tic
for i=1:length(alphas)
    % As a simple test, we compute the distance between two histograms with
    % varying alpha.  As alpha increases, the matrix T gets blurrier and in
    % all cases should approximate the identity matrix.
    
    [distance,T] = EMDsolution(p,q,D,alphas(i));
    figure; imagesc(T); axis equal; axis off;
    title(sprintf('alpha = %g',alphas(i)));
end
toc % 0.952616 seconds on Justin's laptop

% TODO:  Come up with a test or two to illustrate the behavior of
% (regularized) EMD